﻿using System;
using System.ComponentModel.Composition;
using System.Windows.Forms;
using MefEnabled.Interfaces;

namespace MefEnabled
{
    [Export("MainWindow")]
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        [Import] private GeneratorSelector Selector;
        [Import] private GeneratorManager GeneratorManager;
        [Import] private DisplayData Data;

        private void Form1_Load(object sender, EventArgs e)
        {
            Selector.GeneratorChanged += selector_GeneratorChanged;
            topPanel.Controls.Add(Selector);

            dataPanel.Controls.Add(Data);
        }

        void selector_GeneratorChanged(object source, IGenerator generator)
        {
            Data.Display(generator);
        }

        [Import(AllowRecomposition = true)]
        public ILogger Logger { get; set; }

        private void button1_Click(object sender, EventArgs e)
        {
            Logger.Write("message");
        }
    }
}