﻿using System;
using System.Windows.Forms;

namespace MEF_Old20Approach
{
    public partial class GeneratorSelector : UserControl
    {
        public GeneratorManager Manager { get; set; }



        public GeneratorSelector(GeneratorManager manager)
        {
            Manager = manager;
            InitializeComponent();

            manager.LoadExternalGeneratorAssemblies();

            foreach (var type in manager.GetGenerators())
            {
                GeneratorItem item = new GeneratorItem() {Generator = type, Name = Manager.GetName(type)};
                generators.Items.Add(item);
            }
        }

        class GeneratorItem
        {
            public string Name { get; set; }

            public Type Generator { get; set; }

            public override string ToString()
            {
                return Name;
            }
        }

        private void generators_SelectedIndexChanged(object sender, EventArgs e)
        {
            GeneratorItem generatorItem = generators.SelectedItem as GeneratorItem;
            IGenerator instance = Activator.CreateInstance(generatorItem.Generator) as IGenerator;
            if (instance == null)
                return;

            if(GeneratorChanged != null)
                GeneratorChanged(this, instance);
        }

        public delegate void SelectedGeneratorEventHandler(object source, IGenerator generator);
        public event SelectedGeneratorEventHandler GeneratorChanged; 

    }
}
