﻿using System.Collections;
using System.ComponentModel.Composition;
using MefEnabled.Interfaces;

namespace MefEnabled.GeneratorsContrib
{
    [Export(typeof(IGenerator))]
    [Generator("Generator from the community")]
    public class DDDGenerator : IGenerator
    {
        public IEnumerable Get()
        {
            return new[] {"DDD Belfast", "DDD Scotland", "DDD", "DDD South West"};
        }
    }

    [Export(typeof(ILogger))]
    public class MsgBoxLogger : ILogger
    {
        LoggerForm form;

        public MsgBoxLogger()
        {
            form = new LoggerForm();
            form.TopMost = true;
            form.Show();
        }

        public void Write(string message)
        {
            form.Log(message);
        }
    }
}
