using System.ComponentModel.Composition;
using System.ComponentModel.Composition.Hosting;
using System.Reflection;
using System.IO;

namespace MefEnabled
{
    public class Extender
    {
        CompositionContainer container;

        //[Import]
        //public ILogger Logger { get; set; }

        public void Compose()
        {
            AggregateCatalog catalog = new AggregateCatalog();
            AssemblyCatalog assemblyCatalog = new AssemblyCatalog(Assembly.GetExecutingAssembly());
            DirectoryCatalog directoryCatalog = new DirectoryCatalog(Path.Combine(Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location),
                                                                          "Generators"), true);

            catalog.Catalogs.Add(assemblyCatalog);
            catalog.Catalogs.Add(directoryCatalog);

            CatalogExportProvider mainProvider = new CatalogExportProvider(assemblyCatalog);
            container = new CompositionContainer(catalog, mainProvider);
            mainProvider.SourceProvider = container;

            var batch = new CompositionBatch();
            batch.AddPart(this);
            container.Compose(batch);

            //Logger.Write("Compose complete");
        }
    }
}