using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using MefEnabled.Interfaces;

namespace MefEnabled
{
    [Export]
    public class GeneratorManager : INotifyImportSatisfaction
    {
        public delegate void GeneratorLoadedEventHandler(object source, EventArgs args);
        public event GeneratorLoadedEventHandler GeneratorLoaded; 

        public string GetName(Type instance)
        {
            object[] generatorAttributes = instance.GetCustomAttributes(typeof(GeneratorAttribute), false);

            return ((GeneratorAttribute)generatorAttributes[0]).DisplayName;
        }

        [Import(AllowRecomposition = true)] 
        public List<IGenerator> Generators {get;set;}

        [Import]
        public ILogger Logger { get; set; }

        public void ImportCompleted()
        {
            Logger.Write("Import has completed");
            if (GeneratorLoaded != null)
                GeneratorLoaded(this, EventArgs.Empty);
        }
    }
}